VERSION 5.00
Object = "{F9043C88-F6F2-101A-A3C9-08002B2F49FB}#1.2#0"; "COMDLG32.OCX"
Begin VB.Form frmMain 
   Caption         =   "System Menu Editor"
   ClientHeight    =   3030
   ClientLeft      =   60
   ClientTop       =   345
   ClientWidth     =   3750
   LinkTopic       =   "Form1"
   ScaleHeight     =   3030
   ScaleWidth      =   3750
   StartUpPosition =   3  'Windows Default
   Begin VB.TextBox txtCommand 
      Appearance      =   0  'Flat
      Height          =   285
      Left            =   1440
      TabIndex        =   13
      Top             =   2160
      Width           =   1815
   End
   Begin VB.TextBox txtDisplay 
      Appearance      =   0  'Flat
      Height          =   285
      Left            =   1440
      TabIndex        =   11
      Top             =   1800
      Width           =   1815
   End
   Begin VB.TextBox txtShellKey 
      Appearance      =   0  'Flat
      Height          =   285
      Left            =   1440
      TabIndex        =   9
      Top             =   1440
      Width           =   1815
   End
   Begin VB.TextBox txtKeyRef 
      Appearance      =   0  'Flat
      Height          =   285
      Left            =   1440
      TabIndex        =   7
      Top             =   1080
      Width           =   1815
   End
   Begin VB.CommandButton cmdLookup 
      Caption         =   "&Look Up"
      Height          =   255
      Left            =   2400
      TabIndex        =   6
      Top             =   720
      Width           =   855
   End
   Begin VB.TextBox txtExt 
      Appearance      =   0  'Flat
      Height          =   285
      Left            =   1440
      TabIndex        =   4
      Top             =   720
      Width           =   855
   End
   Begin VB.CommandButton cmdCancel 
      Caption         =   "&Cancel"
      Height          =   255
      Left            =   2520
      TabIndex        =   3
      Top             =   2640
      Width           =   735
   End
   Begin VB.CommandButton cmdApply 
      Caption         =   "&Apply"
      Enabled         =   0   'False
      Height          =   255
      Left            =   1680
      TabIndex        =   2
      Top             =   2640
      Width           =   735
   End
   Begin VB.CommandButton cmdOk 
      Caption         =   "&Ok"
      Enabled         =   0   'False
      Height          =   255
      Left            =   840
      TabIndex        =   1
      Top             =   2640
      Width           =   735
   End
   Begin MSComDlg.CommonDialog Dialog 
      Left            =   3240
      Top             =   0
      _ExtentX        =   847
      _ExtentY        =   847
      _Version        =   393216
   End
   Begin VB.CommandButton cmdGetApp 
      Caption         =   "..."
      Height          =   240
      Left            =   3360
      TabIndex        =   0
      Top             =   2160
      Width           =   280
   End
   Begin VB.Label Label1 
      Caption         =   "Enter the following information to create a custom menu item"
      Height          =   375
      Left            =   120
      TabIndex        =   15
      Top             =   120
      Width           =   2895
   End
   Begin VB.Label Label6 
      Caption         =   "Command Value"
      Height          =   255
      Left            =   120
      TabIndex        =   14
      Top             =   2160
      Width           =   1215
   End
   Begin VB.Label Label5 
      Caption         =   "Display Value"
      Height          =   255
      Left            =   120
      TabIndex        =   12
      Top             =   1800
      Width           =   1095
   End
   Begin VB.Label Label4 
      Caption         =   "Shell Key"
      Height          =   255
      Left            =   120
      TabIndex        =   10
      Top             =   1440
      Width           =   1095
   End
   Begin VB.Label Label3 
      Caption         =   "Key Reference"
      Height          =   255
      Left            =   120
      TabIndex        =   8
      Top             =   1080
      Width           =   1095
   End
   Begin VB.Label Label2 
      Caption         =   "File Extension"
      Height          =   255
      Left            =   120
      TabIndex        =   5
      Top             =   720
      Width           =   1095
   End
End
Attribute VB_Name = "frmMain"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
' The Code module was not written by me, as stated in the comments - see code module
' I wrote the following code to interact and provide some ability to add custom menu items
'  to the explorer popup menu.

' This program can be extended to provide ability to add to other system menus
' Deleting of registry keys not implemented, use Regedit instead or extend this program.

' Use at own risk, I take no responsibility if the code doesn't perform as intended.

Option Explicit

Const strKeyName = "THISISADDED"              'this is the main key

Private Sub cmdApply_Click()
    SaveSettings
    cmdApply.Enabled = False
End Sub

Private Sub cmdCancel_Click()
    Unload Me
End Sub

Private Sub cmdGetApp_Click()
    Dialog.Action = 1
    If Dialog.FileName <> "" Then
        txtCommand.Text = Dialog.FileName
        CmdEnabled
    End If
End Sub

Private Sub cmdLookup_Click()
    GetSettings
End Sub

Private Sub cmdOk_Click()
    SaveSettings
    Unload Me
End Sub

Private Sub txtCommand_KeyDown(KeyCode As Integer, Shift As Integer)
    CmdEnabled
End Sub

Private Sub Form_Load()
    txtExt = "txt"
    txtShellKey = strKeyName
        
    GetSettings
    Dialog.Filter = "Executable files (*.exe;*.com)|*.exe;*.com|All Files|*.*"
End Sub

Sub CmdEnabled()
    cmdOk.Enabled = True
    cmdApply.Enabled = True
End Sub

Sub GetSettings()
    Dim tempStr As String
    
    txtKeyRef = GetStringValue("HKEY_CLASSES_ROOT\." & txtExt, "")
    tempStr = GetStringValue("HKEY_CLASSES_ROOT\" + txtKeyRef, "")
    If tempStr <> "Error" Then
        tempStr = GetStringValue("HKEY_CLASSES_ROOT\" + txtKeyRef + "\shell\" + txtShellKey, "")
        If tempStr <> "Error" Then
            txtDisplay = tempStr
            tempStr = GetStringValue("HKEY_CLASSES_ROOT\" + txtKeyRef + "\shell\" + txtShellKey + "\command", "")
            If tempStr = "Error" Then
                txtCommand = "Command Not Found"
            Else
                txtCommand = Mid(tempStr, 2, Len(tempStr) - 5)
            End If
        Else
            txtDisplay = "Value Not Found"
            txtCommand = "Command Not Found"
        End If
    Else
        txtDisplay = "Value Not Found"
        txtCommand = "Command Not Found"
    End If
End Sub

Sub SaveSettings()

    If CheckValues Then
        
        If Not CheckKeys(0) Then
            CreateKey "HKEY_CLASSES_ROOT\" + txtKeyRef + "\SHELL\" + txtShellKey
        End If
        
        If Not CheckKeys(1) Then
            CreateKey "HKEY_CLASSES_ROOT\" + txtKeyRef + "\SHELL\" + txtShellKey + "\Command"
        End If
        
        If (txtCommand <> "Command Not Found") And (txtCommand <> "" And txtDisplay <> "Value Not Found") And (txtDisplay <> "") Then
            SetStringValue "HKEY_CLASSES_ROOT\" + txtKeyRef + "\SHELL\" + txtShellKey, "", txtDisplay
            SetStringValue "HKEY_CLASSES_ROOT\" + txtKeyRef + "\SHELL\" + txtShellKey + "\Command", "", """" & txtCommand & """ %1"
        Else
            MsgBox "Please fill up Command Box" + Chr(13) + "with the path of your program." + Chr(13) + "ie.    c:\windows\notepad.exe     ", vbCritical, "Error"
            txtCommand.SetFocus
        End If
    Else
    End If
    
    GetSettings          'show the result
End Sub

Function CheckKeys(Key As Integer) As Boolean
    Dim tempStr As String
    
    Select Case Key
        Case 0
            tempStr = GetStringValue("HKEY_CLASSES_ROOT\" + txtKeyRef + "\shell\" + txtShellKey, "")
        Case 1
            tempStr = GetStringValue("HKEY_CLASSES_ROOT\" + txtKeyRef + "\shell\" + txtShellKey + "\Command", "")
        Case Else
            tempStr = "Error"
    End Select
    
    If tempStr = "Error" Then
        CheckKeys = False
    End If
End Function

Function CheckValues() As Boolean

    If txtExt = "" Then
        CheckValues = False
    ElseIf txtKeyRef = "" Then
        CheckValues = False
    ElseIf txtShellKey = "" Then
        CheckValues = False
    ElseIf txtDisplay = "" Then
        CheckValues = False
    ElseIf txtCommand = "" Then
        CheckValues = False
    Else
        CheckValues = True
    End If

End Function
